#include <stdbool.h>

typedef struct square_s{
    int* position;
    int coordSize;

    int color;

} square_s;
typedef square_s* Square;

typedef struct Grid{
    Square** grid;

    int width;
    int height;
} Grid;

typedef struct Piece{
    Square* squares;
    int size;
} Piece;

Grid gridInit();
Grid initSquares(Grid g);
Piece pieceInit();

bool gameOver(Grid grid);
int height(Grid g);
int heightColumn(Square* column, int size);

bool canMove(Piece piece, Grid grid);
bool canMoveSquare(Square sq, Grid g);

void move(Piece piece);
void moveSquare(Square sq);

void addPieceToGrid(Piece piece, Grid grid);
void addSquareToGrid(Square sq, Grid g);